 #Compile Exe
#Dim All
#Include "WIN32API.INC"
%ID_BUTTON1 = 100
%ID_BUTTON2 = 101
%ID_THUMBPIC = 112
Global ghImage As Dword
Global hThumb As Dword
Global hDlg As Dword
Global lAspect As Long
Type GdiplusStartupInput
GdiplusVersion As Dword
DebugEventCallback As Dword
SuppressBackgroundThread As Long
SuppressExternalCodecs As Long
End Type
Type GdiplusStartupOutput
NotificationHook As Dword
NotificationUnhook As Dword
End Type
Declare Function GdiplusStartup Lib "GDIPLUS.DLL" Alias "GdiplusStartup" _
(token As Dword, inputbuf As GdiplusStartupInput, outputbuf As GdiplusStartupOutput) As Long

Declare Sub GdiplusShutdown Lib "GDIPLUS.DLL" Alias "GdiplusShutdown" _
(ByVal token As Dword)

Declare Function GdipDeleteGraphics Lib "GDIPLUS.DLL" Alias "GdipDeleteGraphics" _
(ByVal lpGraphics As Dword) As Long

Declare Function GdipCreateFromHDC Lib "GDIPLUS.DLL" Alias "GdipCreateFromHDC" _
(ByVal hdc As Dword, lpGraphics As Dword) As Long

Declare Function GdipLoadImageFromFile Lib "GDIPLUS.DLL" Alias "GdipLoadImageFromFile" _
(ByVal flname As String, lpImage As Dword) As Long

Declare Function GdipDisposeImage Lib "GDIPLUS.DLL" Alias "GdipDisposeImage" _
(ByVal lpImage As Dword) As Long

Declare Function GdipGetImageWidth Lib "GDIPLUS.DLL" Alias "GdipGetImageWidth" _
(ByVal lpImage As Dword, nWidth As Dword) As Long

Declare Function GdipGetImageHeight Lib "GDIPLUS.DLL" Alias "GdipGetImageHeight" _
(ByVal lpImage As Dword, nHeight As Dword) As Long

Declare Function GdipDrawImageRectI Lib "GDIPLUS.DLL" Alias "GdipDrawImageRectI" _
(ByVal lpGraphics As Dword, ByVal nImage As Dword, ByVal x As Long, _
ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long

Declare Function GdipGetImageThumbnail Lib "gdiplus.dll" Alias "GdipGetImageThumbnail" _
(ByVal nImage As Long, ByVal thumbWidth As Long, ByVal thumbHeight As Long, _
thumbnImage As Long, Optional ByVal pCALLBACK As Long, _
Optional ByVal callbackData As Long) As Long
'----------------------------------------------------------------------
Function GDIP_Graphics_CreateFromHDC(ByVal hDC As Dword) As Dword
Local lRslt As Long, lpGraphics As Dword
lRslt = GdipCreateFromHDC(hDC, lpGraphics)
If lRslt = 0 Then Function = lpGraphics
End Function
'----------------------------------------------------------------------
Function GDIP_Image_GetHeight(ByVal lpImage As Dword) As Dword
Local nStatus As Dword, nHeight As Dword
nStatus = GdipGetImageHeight(lpImage, nHeight)
Function = nHeight
End Function
'----------------------------------------------------------------------
Function GDIP_Image_GetWidth(ByVal lpImage As Dword) As Dword
Local nStatus As Dword, nWidth As Dword
nStatus = GdipGetImageWidth(lpImage, nWidth)
If nStatus = 0 Then Function = nWidth
End Function
'----------------------------------------------------------------------
Function GDIP_Image_LoadFromFile(ByVal flname As String) As Dword
Local nStatus As Dword, lpImage As Dword, uFlName As String
uFlName = UCode$(flname)
nStatus = GdipLoadImageFromFile(uFlName, lpImage)
If nStatus = 0 Then Function = lpImage
End Function
'-------------------------------------------------------------------------------
Sub ResizeImage(ImageData As Long, OrgImageX As Long, OrgImageY As Long, ThumbImageX As Long, ThumbImageY As Long, ByVal KeepAspect As Long)
Local xAspect, yAspect, ImgThumb As Long
Local sScale As Single
If KeepAspect Then
' Preserve original x,y aspect
If OrgImageX Then sScale = ThumbImageX / OrgImageX
If sScale > 1 Then sScale = 1
xAspect = OrgImageX * sScale
yAspect = OrgImageY * sScale
If yAspect > ThumbImageY Then
If OrgImageY Then sScale = ThumbImageY / OrgImageY
xAspect = OrgImageX * sScale
yAspect = OrgImageY * sScale
End If

' Create the thumbnail that fits into ThumbImageX/ThumbImageY size, with original aspect preserved
Call GdipGetImageThumbnail(ImageData, xAspect, yAspect, imgThumb)

ThumbImageX = xAspect
ThumbImageY = yAspect
Else
' Don't keep aspect - size to specified ThumbImageX, ThumbImageY size
Call GdipGetImageThumbnail(ImageData, ThumbImageX, ThumbImageY, imgThumb)
End If

ImageData = ImgThumb
imgThumb = 0

End Sub
'-------------------------------------------------------------------------------
Sub DrawThumbImage(ByVal hWnd As Dword, ByVal hImage As Dword, ByVal ThumbImageX As Long, ByVal ThumbImageY As Long, ByVal lKeepAspect As Long)
Local hDC As Dword
Local nWidth As Dword
Local nHeight As Dword
Local lRslt As Long
Local lpGraphics As Dword
hDC = GETDC(hWnd)
nWidth = GDIP_Image_GetWidth(hImage)
nHeight = GDIP_Image_GetHeight(hImage)
lpGraphics = GDIP_Graphics_CreateFromHDC(hDC)
If lpGraphics Then
Call ResizeImage(hImage, nWidth, nHeight, ThumbImageX, ThumbImageY, lKeepAspect)
lRslt = GdipDrawImageRectI(lpGraphics, hImage, 0, 0, ThumbImageX, ThumbImageY)
End If
If lpGraphics Then GdipDeleteGraphics lpGraphics

RELEASEDC hWnd, hDC
hDC = 0
GdipDisposeImage(hImage)
hImage = 0
lpGraphics = 0
End Sub
'----------------------------------------------------------------------
Function ShowThumbImage(ByVal hWnd As Dword, ByVal ThumbImageX As Long, ByVal ThumbImageY As Long, ByVal lKeepAspect As Long, ByVal FlName As String) As Long
ghImage = GDIP_Image_LoadFromFile(FlName)
DrawThumbImage(hWnd, ghImage, ThumbImageX, ThumbImageY, lKeepAspect)
GdipDisposeImage(ghImage)
ghImage = 0
End Function
'------------------------------------------------------------------------------------------
CallBack Function FBrowseProc As Long
Dim zBuffer As Asciiz * %MAX_PATH

Select Case CbMsg

Case %BFFM_INITIALIZED

Dialog Send CbHndl, %BFFM_SETSELECTION, %TRUE, CbLParam
Dialog Send CbHndl, %BFFM_ENABLEOK, %FALSE, %FALSE

Case %BFFM_SELCHANGED

Call SHGETPATHFROMIDLIST(ByVal CbWParam, zBuffer)

'IF ((GETATTR(zBuffer) AND %ARCHIVE) <> %ARCHIVE) OR ((GETATTR(zBuffer) AND %SUBDIR) = %SUBDIR) THEN
If ((GetAttr(zBuffer) And %SUBDIR) = %SUBDIR) Then
Dialog Send CbHndl, %BFFM_ENABLEOK, %FALSE, %FALSE
Else
Dialog Send CbHndl, %BFFM_ENABLEOK, %TRUE, %TRUE
End If

End Select
End Function
'------------------------------------------------------------------------------------------
Function BrowseForFile(hWnd As Long, Title As String, StartDir As String) As String
Local zbuffer As Asciiz * %max_path
Local zstartdir As Asciiz * %max_path
Local bi As browseinfo
Static lpidlist As Dword
zstartdir = StartDir
bi.hwndowner = hWnd
bi.lpsztitle = StrPtr(Title)
bi.pidlroot = 0
bi.ulflags = %BIF_DONTGOBELOWDOMAIN Or %BIF_STATUSTEXT Or %BIF_BROWSEINCLUDEFILES
bi.lpfncallback = CodePtr(FBrowseProc) ' Files
bi.lparam = VarPtr(zstartdir)
lpidlist = SHBROWSEFORFOLDER(bi)
If lpidlist Then
SHGETPATHFROMIDLIST ByVal lpidlist, zbuffer
Function = zbuffer
Else
Function = ""
End If
End Function
'----------------------------------------------------------------------
CallBack Function MainDlgCallback
Static TempStr As String
Select Case CbMsg

Case %WM_INITDIALOG

' Keep files x, y aspect, %FALSE = don't keep
lAspect = %TRUE

Case %WM_PAINT
Case %WM_COMMAND

Select Case CbCtl

Case %ID_BUTTON1
TempStr = BrowseForFile(CbHndl, "Select Image File", CurDir$)
If Len(TempStr) Then ShowThumbImage(GETDLGITEM(hDlg, %ID_THUMBPIC), 150, 150, lAspect, TempStr)

Case %ID_BUTTON2

Control Get Check CbHndl, %ID_BUTTON2 To lAspect

End Select

Case %WM_DESTROY

End Select
End Function
'----------------------------------------------------------------------
Function PBMain
Local StartupInput As GdiplusStartupInput
Local StartupOutput As GdiplusStartupOutput
Local token As Dword, nStatus As Long
Local lRslt As Long
StartupInput.GdiplusVersion = 1
'nStatus = GdiplusStartup(token, StartupInput, BYVAL %NULL)
nStatus = GdiplusStartup(token, StartupInput, StartupOutput)
If nStatus Then
MsgBox "Error initializing GDI+"
Exit Function
End If
Dialog New Pixels, 0, "GDI Thumb Test", , , 170, 215, %WS_SYSMENU To hDlg

Control Add Image, hDlg, %ID_THUMBPIC, "", 10, 10, 150, 150, %SS_SUNKEN, %WS_EX_STATICEDGE
'CONTROL ADD GRAPHIC, hDlg, %ID_THUMBPIC, "", 100, 50, 150, 150, %SS_SUNKEN, %WS_EX_STATICEDGE
Control Handle hDlg, %ID_THUMBPIC To hThumb

Control Add Button, hDlg, %ID_BUTTON1, "Browse for image file", 10, 190, 150, 21
Control Add CheckBox, hDlg, %ID_BUTTON2, "Keep image aspect", 10, 170, 140, 14
Control Set Check hDlg, %ID_BUTTON2, 1

Dialog Show Modal hDlg, Call MainDlgCallback To lRslt
Function = lRslt
Call GdiplusShutdown(token)
End Function
